<template>
  <div class="app-container">
    <div class="whole">
      <div class="jieshao">
        <el-row class="box-net">
          <el-col :span="4">
            <img v-show="companyInfo.companyImageUrl!= null && companyInfo.companyImageUrl != ''" class="images"
                 :src="companyInfo.companyImageUrl" alt=""/>
            <img v-show="companyInfo.companyImageUrl== null || companyInfo.companyImageUrl == ''" class="images"
                 src="../../assets/bg.png" alt=""/>
          </el-col>
          <el-col :span="20">
            <div class="className">{{ companyInfo.companyName }}</div>
            <div class="text-whole">
              <div class="line-txt">
                <div class="left-txt">负责人：</div>
                <div class="right-txt">{{ companyInfo.companyDirector }}</div>
              </div>
              <div class="line-txt">
                <div class="left-txt">证书编号：</div>
                <div class="right-txt">{{ companyInfo.certificateNum }}</div>
              </div>
              <div class="line-txt">
                <div class="left-txt">有效期：</div>
                <div class="right-txt">{{ companyInfo.validityDateStart }} - {{ companyInfo.validityDateStart }}</div>
              </div>
              <div class="line-txt">
                <div class="left-txt">重大危险源数量：</div>
                <div class="txt-red">{{ companyInfo.majorHazardSources }}</div>
              </div>
              <div class="line-txt">
                <div class="left-txt">所在地区：</div>
                <div class="right-txt">{{ companyInfo.companyCity }}</div>
              </div>
            </div>
          </el-col>
        </el-row>
      </div>
      <section class="">
        <div class="content list_whole">
          <div ref="left">
            <ul class="list_ul">
              <li v-for="(item, index) in left" :key="item" :class="{current: currentIndex == index}"
                  @click="selectItem(index, $event)">
                {{ item }}
              </li>
            </ul>
          </div>
          <div class="right_box" ref="right">
            <ul class="list_right">
              <li v-for="(item,index) in right" style="height:auto;min-height:400px;" class="right-item-hook" :key="index">
                <div class="list_tit">{{ item.name }}</div>
                <div class="list_txt">{{ item.content }}</div>
                <div>
                  <img
                    v-show="item.prop == 'companyInfo' && companyInfo.businessLicenseImageUrl!= null && companyInfo.businessLicenseImageUrl != ''"
                    class="images" :src="companyInfo.businessLicenseImageUrl" alt=""/>
                  <img
                      v-show="item.prop == 'safetyProductionLicenseSituation' && companyInfo.securityCertificateImageUrl!= null && companyInfo.securityCertificateImageUrl != ''"
                    class="images" :src="companyInfo.securityCertificateImageUrl" alt=""/>
                </div>
              </li>
            </ul>
          </div>
        </div>
      </section>
    </div>
  </div>
</template>

<script>
import {
  getOneCompany
} from '@/api/company'
import BScroll from 'better-scroll'

export default {
  name: "details",
  data() {
    return {
      left: ['一、企业介绍', '二、“两重点一重大”情况', '三、生产安全许可证情况', '四、主要安全风险', '五、当前存在问题', '六、主要安全风险防控措施'],
      right: [
        {
          name: '一、企业介绍',
          prop: "companyInfo",
          // content: "国家管网集团联合管道有限责任公司西部塔里木输油气分公司机关位于新疆巴州库尔勒市建设路辖区塔指东路塔指院内五区，公司成立于2003年4月，2019年1月1日，轮库复线、轮库气线等资产及管理划转到塔里木油田公司，2020年10月1日，整建制划入国家管网集团公司，业务实现了从“以油为主”到“油气并举”的转变。 主要负责西部管道南疆原油及天然气的交接计量、管道储运管理及维修抢修工作。分公司所辖油气阀室34座，其中气线阀室24座，油线阀室10座。现有员工247人，其中党员119人，占员工总数的48%，安全管理人员48人。塔里木输油气分公司库尔勒原油站位于新疆巴州库尔勒市上户镇库尔勒西立交桥东南1公里处，占地面积三万平方米，年输送原油能力为500万方，共有三座5万方原油储罐，总罐容15万方。"
        },
        {
          name: '二、“两重点一重大”情况',
          prop: "keynoteGreatSituation",
          // content: "国家管网集团联合管道有限责任公司西部塔里木输油气分公司机关位于新疆巴州库尔勒市建设路辖区塔指东路塔指院内五区，公司成立于2003年4月，2019年1月1日，轮库复线、轮库气线等资产及管理划转到塔里木油田公司，2020年10月1日，整建制划入国家管网集团公司，业务实现了从“以油为主”到“油气并举”的转变。 主要负责西部管道南疆原油及天然气的交接计量、管道储运管理及维修抢修工作。分公司所辖油气阀室34座，其中气线阀室24座，油线阀室10座。现有员工247人，其中党员119人，占员工总数的48%，安全管理人员48人。塔里木输油气分公司库尔勒原油站位于新疆巴州库尔勒市上户镇库尔勒西立交桥东南1公里处，占地面积三万平方米，年输送原油能力为500万方，共有三座5万方原油储罐，总罐容15万方。"
        },
        {
          name: '三、生产安全许可证情况',
          prop: "safetyProductionLicenseSituation",
          // content: "国家管网集团联合管道有限责任公司西部塔里木输油气分公司机关位于新疆巴州库尔勒市建设路辖区塔指东路塔指院内五区，公司成立于2003年4月，2019年1月1日，轮库复线、轮库气线等资产及管理划转到塔里木油田公司，2020年10月1日，整建制划入国家管网集团公司，业务实现了从“以油为主”到“油气并举”的转变。 主要负责西部管道南疆原油及天然气的交接计量、管道储运管理及维修抢修工作。分公司所辖油气阀室34座，其中气线阀室24座，油线阀室10座。现有员工247人，其中党员119人，占员工总数的48%，安全管理人员48人。塔里木输油气分公司库尔勒原油站位于新疆巴州库尔勒市上户镇库尔勒西立交桥东南1公里处，占地面积三万平方米，年输送原油能力为500万方，共有三座5万方原油储罐，总罐容15万方。"
        },
        {
          name: '四、主要安全风险',
          prop: "keynoteGreatSituation",
          // content: "国家管网集团联合管道有限责任公司西部塔里木输油气分公司机关位于新疆巴州库尔勒市建设路辖区塔指东路塔指院内五区，公司成立于2003年4月，2019年1月1日，轮库复线、轮库气线等资产及管理划转到塔里木油田公司，2020年10月1日，整建制划入国家管网集团公司，业务实现了从“以油为主”到“油气并举”的转变。 主要负责西部管道南疆原油及天然气的交接计量、管道储运管理及维修抢修工作。分公司所辖油气阀室34座，其中气线阀室24座，油线阀室10座。现有员工247人，其中党员119人，占员工总数的48%，安全管理人员48人。塔里木输油气分公司库尔勒原油站位于新疆巴州库尔勒市上户镇库尔勒西立交桥东南1公里处，占地面积三万平方米，年输送原油能力为500万方，共有三座5万方原油储罐，总罐容15万方。"
        },
        {
          name: '五、当前存在问题',
          prop: "currentProblems",
          // content: "国家管网集团联合管道有限责任公司西部塔里木输油气分公司机关位于新疆巴州库尔勒市建设路辖区塔指东路塔指院内五区，公司成立于2003年4月，2019年1月1日，轮库复线、轮库气线等资产及管理划转到塔里木油田公司，2020年10月1日，整建制划入国家管网集团公司，业务实现了从“以油为主”到“油气并举”的转变。 主要负责西部管道南疆原油及天然气的交接计量、管道储运管理及维修抢修工作。分公司所辖油气阀室34座，其中气线阀室24座，油线阀室10座。现有员工247人，其中党员119人，占员工总数的48%，安全管理人员48人。塔里木输油气分公司库尔勒原油站位于新疆巴州库尔勒市上户镇库尔勒西立交桥东南1公里处，占地面积三万平方米，年输送原油能力为500万方，共有三座5万方原油储罐，总罐容15万方。"
        },
        {
          name: '六、主要安全风险防控措施',
          prop: "safetyRiskControlMeasures",
          // content: "国家管网集团联合管道有限责任公司西部塔里木输油气分公司机关位于新疆巴州库尔勒市建设路辖区塔指东路塔指院内五区，公司成立于2003年4月，2019年1月1日，轮库复线、轮库气线等资产及管理划转到塔里木油田公司，2020年10月1日，整建制划入国家管网集团公司，业务实现了从“以油为主”到“油气并举”的转变。 主要负责西部管道南疆原油及天然气的交接计量、管道储运管理及维修抢修工作。分公司所辖油气阀室34座，其中气线阀室24座，油线阀室10座。现有员工247人，其中党员119人，占员工总数的48%，安全管理人员48人。塔里木输油气分公司库尔勒原油站位于新疆巴州库尔勒市上户镇库尔勒西立交桥东南1公里处，占地面积三万平方米，年输送原油能力为500万方，共有三座5万方原油储罐，总罐容15万方。"
        },
        {
          name: '',
          content: ""
        },
      ],
      listHeight: [],
      scrollY: 0, //实时获取当前y轴的高度
      clickEvent: false,
      companyInfo: {}
    }
  },
  methods: {
    _initScroll() {
      //better-scroll的实现原理是监听了touchStart,touchend事件，所以阻止了默认的事件（preventDefault）
      //所以在这里做点击的话，需要在初始化的时候传递属性click,派发一个点击事件
      //在pc网页浏览模式下，点击事件是不会阻止的，所以可能会出现2次事件，所以为了避免2次，可以在绑定事件的时候把$event传递过去
      this.lefts = new BScroll(this.$refs.left, {
        click: true
      })
      this.rights = new BScroll(this.$refs.right, {
        probeType: 3  //探针的效果，实时获取滚动高度
      })
      //rights这个对象监听事件，实时获取位置pos.y
      this.rights.on('scroll', (pos) => {
        this.scrollY = Math.abs(Math.round(pos.y))
      })
    },
    _getHeight() {
      let rightItems = this.$refs.right.getElementsByClassName('right-item-hook')
      let height = 0
      this.listHeight.push(height)
      for (let i = 0; i < rightItems.length; i++) {
        let item = rightItems[i]
        height += item.clientHeight
        this.listHeight.push(height)
      }
    },
    selectItem(index, event) {
      this.clickEvent = true
      //在better-scroll的派发事件的event和普通浏览器的点击事件event有个属性区别_constructed
      //浏览器原生点击事件没有_constructed所以当时浏览器监听到该属性的时候return掉
      if (!event._constructed) {
        return
      } else {
        let rightItems = this.$refs.right.getElementsByClassName('right-item-hook')
        let el = rightItems[index]
        this.rights.scrollToElement(el, 300)
      }
    },
    getOneData(data) {
      getOneCompany(data).then(res => {
        this.companyInfo = res.data
        if (this.companyInfo.companyImage) {
          this.companyInfo.companyImageUrl = process.env.VUE_APP_BASE_API + this.companyInfo.companyImage
        }
        if (this.companyInfo.businessLicense) {
          this.companyInfo.businessLicenseImageUrl = process.env.VUE_APP_BASE_API + this.companyInfo.businessLicense
        }
        if (this.companyInfo.securityCertificate) {
          this.companyInfo.securityCertificateImageUrl = process.env.VUE_APP_BASE_API + this.companyInfo.securityCertificate
        }
        for (let item of this.right) {
          item.content = this.companyInfo[item.prop]
        }
      }).catch(function () {

      })
    }
  },
  mounted() {
    if (this.$route.query.data != null) {
      this.getOneData(this.$route.query.data);
    } else {
      this.getOneData({});
    }

    this.$nextTick(() => {
      this._initScroll()
      this._getHeight()
    })
    // scroll() {
    new BScroll(document.querySelector('.right_box'), {
      mouseWheel: true,//开启鼠标滚轮
      disableTouch: false
    })
    // }
  },
  computed: {
    currentIndex() {
      for (let i = 0; i < this.listHeight.length; i++) {
        let height = this.listHeight[i]
        let height2 = this.listHeight[i + 1]
        //当height2不存在的时候，或者落在height和height2之间的时候，直接返回当前索引
        //>=height，是因为一开始this.scrollY=0,height=0
        if (!height2 || (this.scrollY >= height && this.scrollY < height2)) {
          return i
        }
        if (this.listHeight[this.listHeight.length - 1] - this.$refs.right.clientHeight <= this.scrollY) {
          if (this.clickTrue) {
            return this.currentNum
          } else {
            return (this.listHeight.length - 1)
          }
        }
      }
      //如果this.listHeight没有的话，就返回0
      return 0
    }
  },

}
</script>

<style scoped>
ul, li, ol {
  list-style: none;
}

.whole {
  background: #ffffff;
}

.jieshao {
  padding: 20px;
}

.box-net {
  padding: 10px;
  background: #fbfcff;
}

.images {
  width: 250px;
  padding: 10px;
}

.className {
  font-size: 18px;
  font-weight: bolder;
  line-height: 30px;
}

.text-whole {
  margin: 10px 0;
  border-radius: 5px;
}

.line-txt {
  display: flex;
  align-items: center;
  justify-content: flex-start;
  line-height: 30px;
  color: #808183;
}

.right-txt {
  /*font-weight: bold;*/
  color: #000000;
}

.txt-red {
  color: red;
}

/* .list_whole{
  display: flex;
  justify-content: space-between;
} */
.list_ul {
  width: 15vw;
  margin: 0;
  padding: 0 25px 0 47px;
}

.list_ul li {
  padding: 20px 0;
  border-bottom: 1px solid #e4e8eb;
}

.list_right {
  width: 100%;
  padding-left: 0;
}

.list_tit {
  text-align: center;
  font-size: 20px;
  font-weight: bold;
  margin-bottom: 20px;
}

.list_txt {
  margin-bottom: 30px;
}

.content {
  display: flex;
  position: absolute;
  top: 30%;
  bottom: 0;
  width: 98%;
  height: 500px;
  overflow: hidden;
  background: #fff;
  padding: 10px 0;
}

.current {
  color: dodgerblue;
}

.right_box {
  overflow: hidden;
  height: 100%;
  width: 100%;
  padding: 10px 40px;
}
</style>
